package org.example.bindings.domain;

import java.awt.Color;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.util.Date;

public class Person {
    
    private final transient PropertyChangeSupport support = new PropertyChangeSupport(this);
    
    private String name;
    private Date birthDate;
    private Color favouriteColor;
    
    public Person(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        String old = this.name;
        this.name = name;
        support.firePropertyChange("name", old, this.name);
    }
    
    public Date getBirthDate() {
        return birthDate;
    }

    public void setBirthDate(Date birthDate) {
        Date old = this.birthDate;
        this.birthDate = birthDate;
        support.firePropertyChange("birthDate", old, this.birthDate);
    }

    public Color getFavouriteColor() {
        return favouriteColor;
    }

    public void setFavouriteColor(Color favouriteColor) {
        Color old = this.favouriteColor;
        this.favouriteColor = favouriteColor;
        support.firePropertyChange("favouriteColor", old, this.favouriteColor);
   }

    public void addPropertyChangeListener(String property, PropertyChangeListener l) {
        support.addPropertyChangeListener(property, l);
    }
    
    public void addPropertyChangeListener(PropertyChangeListener l) {
        support.addPropertyChangeListener(l);
    }
    
    public void removePropertyChangeListener(PropertyChangeListener l) {
        support.removePropertyChangeListener(l);
    }
    
    public void removePropertyChangeListener(String property, PropertyChangeListener l) {
        support.removePropertyChangeListener(property, l);
    }
}
