package org.example.bindings.gui;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JList;

import org.example.bindings.domain.Person;
import org.jdesktop.beansbinding.BeanProperty;
import org.jdesktop.beansbinding.BindingGroup;
import org.jdesktop.beansbinding.Bindings;
import org.jdesktop.beansbinding.ELProperty;
import org.jdesktop.beansbinding.AutoBinding.UpdateStrategy;
import org.jdesktop.observablecollections.ObservableCollections;
import org.jdesktop.swingbinding.JListBinding;
import org.jdesktop.swingbinding.SwingBindings;

public class JSR295BindingsPanel extends BindingsPanel<Person> {

    private List<Person> persons = ObservableCollections.observableList(new ArrayList<Person>());
    
    @Override
    protected List<Person> createPersons(String... names) {
        List<Person> result = new ArrayList<Person>();
        for(String name : names) {
            result.add(new Person(name));
        }
        return result;
    }

    @Override
    public void setPersons(List<Person> persons) {
        // does not work, unless you rebind it I
//        List<Person> old = this.persons;
//        this.persons = ObservableCollections.observableList(persons);
        
      List<Person> old = new ArrayList<Person>(this.persons);
      this.persons.clear();
      this.persons.addAll(persons);
      firePropertyChange("persons", old, this.persons);
    }
    
    @Override
    protected void initBindings() {
        BindingGroup group = new BindingGroup();
        JListBinding<Person, List<Person>, JList> listBinding =
            SwingBindings.createJListBinding(
                UpdateStrategy.READ, persons, list);
        
        BeanProperty<Person, String> render = BeanProperty.create("name");
        listBinding.setDetailBinding(render);
        
        group.addBinding(listBinding);
        
        group.addBinding(Bindings.createAutoBinding(
                UpdateStrategy.READ,
                list, ELProperty.create("${selectedElement_IGNORE_ADJUSTING.name}"),
                nameTextField, BeanProperty.create("text"))); 

        group.addBinding(Bindings.createAutoBinding(
                UpdateStrategy.READ,
                list, ELProperty.create("${selectedElement_IGNORE_ADJUSTING != null}"),
                nameTextField, BeanProperty.create("enabled")));
        
        group.bind();
    }
}
