package org.example.caricature;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.EventQueue;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;

import net.java.dev.properties.Property;
import net.java.dev.properties.binding.swing.adapters.SwingBind;
import net.miginfocom.swing.MigLayout;

public class BeanPropertiesCaricatureDemo extends JFrame {

    public BeanPropertiesCaricatureDemo() {
        super("Bean-properties Caricature Demo");
        
        BPCaricature caricature = new BPCaricature();
        JPanel sliders = new JPanel(new MigLayout("", "[right|fill]"));
        sliders.setBorder(BorderFactory.createTitledBorder("Style"));
        createSlider(sliders, caricature.eyeStyle);
        createSlider(sliders, caricature.faceStyle);
        createSlider(sliders, caricature.hairStyle);
        createSlider(sliders, caricature.mouthStyle);
        createSlider(sliders, caricature.noseStyle);
        
        JPanel effects = new JPanel(new MigLayout("", "[right|fill]"));
        effects.setBorder(BorderFactory.createTitledBorder("Effects"));
        createSlider(effects, caricature.rotation, 0, 360, 90);
        createSlider(effects, caricature.scaleInt, 25, 175, 25);
        
        MigLayout layout = new MigLayout();
        layout.setRowConstraints("[fill]");
        JPanel controls = new JPanel(layout);
        controls.add(sliders, "pushy");
        controls.add(effects, "pushy");
        
        Container content = getContentPane();
        content.setLayout(new BorderLayout());
        content.add(caricature, BorderLayout.CENTER);
        content.add(controls, BorderLayout.PAGE_END);
    }
    
    private JSlider createSlider(JPanel sliders, Property<Integer> property) {
        return createSlider(sliders, property, 1, 5, -1);
    }
    
    private JSlider createSlider(JPanel sliders, Property<Integer> property,
            int min, int max, int ticks) {
        sliders.add(new JLabel(property.getContext().getDisplayName()));
        
        JSlider slider = new JSlider();
        sliders.add(slider, "pushx, wrap");
        
        SwingBind.get().bind(property, slider);
        
        slider.setMinimum(min);
        slider.setMaximum(max);
        if(ticks > 0) {
            slider.setMajorTickSpacing(ticks);
            slider.setPaintTicks(true);
            slider.setPaintLabels(true);
        }
        else {
            slider.setSnapToTicks(true);
        }
        return slider;
    }

    public static void main(String[] args) {
        EventQueue.invokeLater(new Runnable() {
            public void run() {
                BeanPropertiesCaricatureDemo demo = new BeanPropertiesCaricatureDemo();
                demo.setDefaultCloseOperation(EXIT_ON_CLOSE);
                demo.pack();
                demo.setLocationByPlatform(true);
                demo.setVisible(true);
            }
        });
    }

}
